<template>
    <div>
        <div class="form-group form-inline edit__set_block white-space">
            <h4 class="mb-4">
                Timer Settings
            </h4>
            <div class="full-width">
                <div class="row mb-4">
                    <div class="col-md-12">
                        <validation-element
                            v-model="popup.timer_pre_text"
                            label="Timer Text:"
                            name="timer text"
                            custom-label-class="label_light"
                            custom-input-class="form-control"
                        />
                    </div>
                </div>
            </div>
            <div class="row mb-4">
                <div class="col-12 mb-2 col-md-6">
                    <div class="full-width">
                        <validation-element
                            v-model="popup.timer_text_size"
                            label="Timer Text Size:"
                            name="timer text size"
                            input-type="number"
                            :input-min="2"
                            :input-max="40"
                            custom-label-class="label_light"
                        />
                    </div>
                </div>
                <div class="col-12 mb-2 col-md-6">
                    <div class="full-width">
                        <div class="title-text">
                            Timer Text Color
                        </div>
                        <div class="jscolor-group">
                            <b-form-input
                                id="timer-pre-text"
                                v-model="popup.colors.timer_pre_text_color"
                                data-vv-as="Header Color"
                                type="text"
                                class="my-input full-width"
                            />
                            <button
                                :style="{background: popup.colors.timer_pre_text_color}"
                                class="btn btn-color"
                                type="button"
                                @click="showPicker('timerPreTextActive')"
                            />

                            <div
                                v-show="timerPreTextActive.active"
                                class="chrome-picker"
                            >
                                <chrome-picker v-model="timerPreText" />
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="full-width mb-4">
                <div class="row">
                    <div class="col-md-12">
                        Timer Duration:
                    </div>
                </div>
            </div>
            <div class="row mb-4">
                <div class="col-12 mb-2 col-md-4">
                    <validation-element
                        id="hours"
                        v-model="popup.hours"
                        label="Hours:"
                        name="hours"
                        input-type="number"
                        :input-min="0"
                        :input-max="99"
                        custom-label-class="label_light"
                    />
                </div>
                <div class="col-12 mb-2 col-md-4">
                    <validation-element
                        id="minutes"
                        v-model="popup.minutes"
                        :input-max="59"
                        :input-min="0"
                        input-type="number"
                        label="Minutes:"
                        name="minutes"
                        custom-label-class="label_light"
                    />
                </div>
                <div class="col-12 mb-2 col-md-4">
                    <validation-element
                        id="seconds"
                        v-model="popup.seconds"
                        :input-max="59"
                        :input-min="0"
                        input-type="number"
                        label="Seconds:"
                        name="seconds"
                        custom-label-class="label_light"
                    />
                </div>
            </div>
            <div
                v-if="!showNewModal"
                class="full-width mb-4"
            >
                <div class="row">
                    <div class="col-12 mb-2 col-md-6">
                        <div class="title-text">
                            Timer Style
                        </div>
                        <b-select
                            id="icon_style"
                            v-model="popup.timer_style"
                            style="background-color: white;"
                            type="text"
                            class="my-select-menu full-width mb-0"
                        >
                            <option value="1">
                                Style 1
                            </option>
                            <option value="2">
                                Style 2
                            </option>
                        </b-select>
                    </div>
                </div>
            </div>
            <div v-if="popup.timer_style == 2">
                <div>Timer Text</div>
                <div class="row mb-4">
                    <div class="col-12 mb-2 col-md-4">
                        <validation-element
                            id="hours_text"
                            v-model="popup.hours_text"
                            label="Hours:"
                            name="hours"
                            custom-label-class="label_light"
                        />
                    </div>
                    <div class="col-12 mb-2 col-md-4">
                        <validation-element
                            id="minutes_text"
                            v-model="popup.minutes_text"
                            label="Minutes:"
                            name="minutes"
                            custom-label-class="label-light"
                        />
                    </div>
                    <div class="col-12 mb-2 col-md-4">
                        <validation-element
                            id="seconds_text"
                            v-model="popup.seconds_text"
                            label="Seconds:"
                            name="seconds"
                            custom-label-class="label-light"
                        />
                    </div>
                </div>
            </div>
            <div class="row mb-4">
                <div class="col-12 mb-2 col-md-6">
                    <div class="full-width">
                        <div class="title-text">
                            Timer Background Color
                        </div>
                        <div class="jscolor-group">
                            <b-form-input
                                id="timer-background"
                                v-model="popup.colors.timer_background"
                                data-vv-as="Header Color"
                                type="text"
                                class="my-input full-width"
                            />
                            <button
                                :style="{background: popup.colors.timer_background}"
                                class="btn btn-color"
                                type="button"
                                @click="showPicker('timerBackgroundActive')"
                            />

                            <div
                                v-show="timerBackgroundActive.active"
                                class="chrome-picker"
                            >
                                <chrome-picker v-model="background" />
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-12 mb-2 col-md-6">
                    <div class="full-width">
                        <div class="title-text">
                            Timer Text Color
                        </div>
                        <div class="jscolor-group">
                            <b-form-input
                                id="timer-text"
                                v-model="popup.colors.timer_text"
                                data-vv-as="Header Color"
                                type="text"
                                class="my-input full-width"
                            />
                            <button
                                :style="{background: popup.colors.timer_text}"
                                class="btn btn-color"
                                type="button"
                                @click="showPicker('timerTextActive')"
                            />

                            <div
                                v-show="timerTextActive.active"
                                class="chrome-picker"
                            >
                                <chrome-picker v-model="timerText" />
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import {Chrome} from 'vue-color';
import ValidationElement from '../elements/ValidationElement.vue';

export default {
    name: "TimerSettings",
    components: {
        'chrome-picker': Chrome,
        ValidationElement
    },

    props: {
        popup: Object,
        showNewModal: Boolean,
    },
    data() {
        return {
            timerBackgroundActive: {active: false},
            timerTextActive: {active: false},
            timerPreTextActive: {active: false},
            timerPreText: '',
            background: '',
            timerText: ''
        }
    },
    watch: {
        background: {
            deep: true,
            handler() {
                this.popup.colors.timer_background = this.background.hex;
            }
        },
        timerText: {
            deep: true,
            handler() {
                this.popup.colors.timer_text = this.timerText.hex;
            }
        },
        timerPreText: {
            deep: true,
            handler() {
                this.popup.colors.timer_pre_text_color = this.timerPreText.hex;
            }
        },
    },
    methods: {
        showPicker(val) {
            this.hidePicker();
            document.addEventListener('click', this.documentClick);

            this[val].active = true;
        },
        hidePicker() {
            document.removeEventListener('click', this.documentClick);

            this.timerBackgroundActive.active = false;
            this.timerTextActive.active = false;
            this.timerPreTextActive.active = false;
        },
        documentClick(e) {
            if (e.target.className.indexOf('btn-color') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hidePicker()
            }
        },
    }
}
</script>

<style scoped>

.my-select-menu {
    height: 40px;
}

.jscolor-group {
    max-width: 100%;
}

.timer-settings-container {
    background: white;
    padding: 20px;
    border-radius: 5px;
}

</style>
